package
{
	import flash.events.Event;
	
	import mx.binding.utils.ChangeWatcher;
	import mx.core.Application;
	import mx.events.PropertyChangeEvent;
	
	public class TranslatorSample8Base extends Application
	{
		private var imanager:IconManager;
		private var gmanager:TranslateManager;
		private var tmanager:TwitterManager;
		
		private var gmodel:TranslateModel;
		private var xmodel:XAuthModel;
		
		private var tweet:Boolean;
		
		public function TranslatorSample8Base():void {
		}
		
		public function initApp():void {
			gmodel = new TranslateModel();
			xmodel = new XAuthModel();
			
			imanager = new IconManager();
			gmanager = new TranslateManager();
			tmanager = new TwitterManager();
			
			imanager.initIconManager(gmodel);
			gmanager.initTranslateManager(gmodel);
			tmanager.initTwitterManager(xmodel);
			
			ChangeWatcher.watch(gmodel, '_result', onResultChangeHandler);
			
			imanager.addEventListener(TranslatorSampleEvent.ICON_CLICK, onIconClick);
			imanager.addEventListener(TranslatorSampleEvent.ICON_TIMER, onIconTimerHandler);
		}
		
		private function onIconClick(event:TranslatorSampleEvent):void {
			if (tweet) {
				this.removeEventListener(Event.ENTER_FRAME, imanager.iconAnimate);
				imanager.timerStop();
				
				tmanager.Tweet(gmodel.Translated.substr(0, 140));
				tweet = false;
			}
			else {
				gmodel.Result = false;
				gmanager.Translate("1.0", gmodel.Original, "en", "ja");
			}
		}
		
		private function onResultChangeHandler(event:PropertyChangeEvent):void {
			if (event.newValue as Boolean) {
				this.addEventListener(Event.ENTER_FRAME, imanager.iconAnimate);
				imanager.timerStart();
				tweet = true;
			}
		}
		
		private function onIconTimerHandler(event:TranslatorSampleEvent):void {
			this.removeEventListener(Event.ENTER_FRAME, imanager.iconAnimate);
			imanager.timerStop();
			tweet = false;
		}
	}
}